local mtnightmare={timer=0,user={}}

minetest.register_on_joinplayer(function(player)
	player:set_sky({}, "skybox", {"mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png"})
end)

minetest.register_on_dignode(function(pos, oldnode, digger)
	minetest.place_node(pos, {name="default:dirt"})
end)

minetest.register_abm({
	nodenames = {"air"},
	interval = 10,
	chance = 100,
	action = function(pos)
		local r=math.random(1,1000)
		if r==1 then
			minetest.place_node(pos, {name="default:sand"})
		elseif r==2 then
			minetest.add_entity(pos, "mtnightmare:jump")

		end
	end
})

for i, v in pairs(minetest.registered_nodes) do
minetest.override_item(v.name,{
	tiles = {{name = "mtnightmare_n.png",
		animation = {
			type = "vertical_frames",
			aspect_w = 8,
			aspect_h = 8,
			length = 0.5,
			},
		},
	},
})
end
mtnightmare.rndhexcolor=function()
	local a="0123456789ABCDEF"
	local a1=math.random(1,16)
	local a2=math.random(1,16)
	return string.sub(a,a1,a1) .. string.sub(a,a2,a2)
end

minetest.register_globalstep(function(dtime)
	mtnightmare.timer = mtnightmare.timer + dtime
	if mtnightmare.timer > 1 then
		minetest.set_timeofday(math.random(0,100)*0.01)
		mtnightmare.timer=0
		for _,player in ipairs(minetest.get_connected_players()) do
			local name = player:get_player_name()
			if mtnightmare.user[name] then player:hud_remove(mtnightmare.user[name]) end
    			local r,g,b=mtnightmare.rndhexcolor(),mtnightmare.rndhexcolor(),mtnightmare.rndhexcolor()
			mtnightmare.user[name]=player:hud_add({
			hud_elem_type = "image",
			text ="mtnightmare_s.png^[colorize:#" .. r .. g .. b .. "aa",
			name = "rndcsc",
			scale = {x=-100, y=-100},
			position = {x=0, y=0},
			alignment = {x=1, y=1},
			})
		end

	end
end)

minetest.register_entity("mtnightmare:jump",{
	hp_max = 10,
	physical =true,
	weight = 1,
	collisionbox = {-0.5,-0.5,-0.5,0.5,0.5,0.5},
	visual = "cube",
	visual_size = {x=1,y=1},
	textures ={"mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png","mtnightmare_n.png"},
	colors = {},
	spritediv = {x=1, y=1},
	initial_sprite_basepos = {x=0, y=0},
	is_visible = true,
	makes_footstep_sound = true,
	automatic_rotate = 0.1,
	on_activate=function(self, staticdata)
		self.object:setacceleration({x =0, y =-10, z =0})
		self.object:setvelocity({x=0,y=-10,z=0})
		return self
	end,
	on_step=function(self, dtime)
		self.time=self.time+dtime
		if self.time<1 then return self end
		self.time=0
		if self.object:getvelocity().y==0 then
			self.time2=self.time2+1
			if self.time2>9 then self.object:remove() return self end
			self.object:setvelocity({x=math.random(-2,2),y=math.random(3,10),z=math.random(-2,2)})
		end
		local pos=self.object:getpos()
		minetest.add_particlespawner({
			amount = 4,
			time =0.2,
			minpos = pos,
			maxpos = pos,
			minvel = {x=-1, y=-8, z=-1},
			maxvel = {x=1, y=-1, z=1},
			minacc = {x=0, y=-8, z=0},
			maxacc = {x=0, y=0, z=0},
			minexptime = 1,
			maxexptime = 2,
			minsize = 1,
			maxsize = 4,
			texture = "mtnightmare_n.png",
			collisiondetection = true,
		})
		return self
	end,
	time=0,
	time2=0,
	type="",
})